#include "Functions.h"
#include <iostream>
#include <fstream>
    
int main(){
    
    std::string bfile = "../I_O-streams-and-stl/Part 2/bfile.bin";
    std::string tfile = "../I_O-streams-and-stl/Part 2/tfile.txt";
    std::string resBfile = "../I_O-streams-and-stl/Part 2/resBfile.bin";
    
    std::string surn;
    BAccount acc;
    int num;
    long code;
    
    try {
        int a = 100;
        while(a != 0){
            std::cout << "1. Create new account(s)" << std::endl;
            std::cout << "2. Create text file from binary" << std::endl;
            std::cout << "3. Delete account by number" << std::endl;
            std::cout << "4. Replace account by number" << std::endl;
            std::cout << "5. Search account by number" << std::endl;
            std::cout << "6. Search accounts by code" << std::endl;
            std::cout << "7. Search accounts by surname" << std::endl;
            std::cout << "0. Exit" << std::endl;
            std::cin >> a;
            
            switch (a) {
                case 1:
                    Fill_File(bfile);
                    break;
                    
                case 2:
                    To_txt(bfile, tfile);
                    break;
                    
                case 3:
                    std::cout << std::endl << "Input account number to delete" << std::endl;
                    std::cin >> num;
                    Delete_Account(num, bfile);
                    break;
                    
                case 4:
                    std::cout << std::endl << "Input account" << std::endl;
                    std::cin >> acc;
                    std::cout << std::endl << "Input account number to replace" << std::endl;
                    std::cin >> num;
                    Replace_Account(num, acc, bfile);
                    break;
                    
                case 5:
                    std::cout << std::endl << "Input account number to search" << std::endl;
                    std::cin >> num;
                    Search_by_Number(num, bfile, resBfile);
                    break;
                    
                case 6:
                    std::cout << std::endl << "Input account code to search" << std::endl;
                    std::cin >> code;
                    Search_by_Code(code, bfile, resBfile);
                    break;
                    
                case 7:
                    std::cout << std::endl << "Input owner's surname to search" << std::endl;
                    std::cin >> surn;
                    Search_by_Surname(surn, bfile, resBfile);
                    break;
                    
                case 0:
                    break;
                default:
                    while((a < 0) || (a > 7)){
                        std::cout << "Wrong number! Try again" << std::endl;
                        std::cin >> a;
                    }
            }
        }
    } catch (const std::exception& err) {
        std::cout << err.what();
    }
    return 0;
}
